//! \file    ModinspaceWindow.cpp
//! \brief   Implementation of the instructions file's window for visual_YAO.
//! \version 2010/10/22 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: ModinspaceWindow.cpp
  Nom de classe: ModinspaceWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/ModinspaceWindow.hpp"

using namespace std;
using namespace yao;


//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

/*********************************************************************************************************************************/
ModinspaceWindow::ModinspaceWindow(Table <Modul> *aModulTable, Table <Space> *aSpaceTable, Table <Operator> *anOperatorTable, Table <Order> *anOrderTable, Order *anOrder, QWidget *parent) : QWidget(parent), m_theLocalAxesTable(NULL), m_theLocalModulTable(NULL) {


	setupUi(this);
	
	m_localModulTable       = aModulTable;
        m_localSpaceTable       = aSpaceTable;
        m_localOperaTable       = anOperatorTable;
        m_localOrderTable       = anOrderTable;
	m_localOrder		= anOrder;	

	m_rightAxesButton->setIcon(QIcon("Images/icons/rightarrow2.png"));
	m_rightModulNameButton->setIcon(QIcon("Images/icons/rightarrow2.png"));

	m_spaceOrOperaNameComboBox->insertItem(0, "");
	m_modulNameComboBox->insertItem(0, "");
	
	m_axesComboBox->insertItem(0, "");
	m_axesComboBox->insertItem(1, "YA1");
	m_axesComboBox->insertItem(2, "YA2");
	m_axesComboBox->insertItem(3, "YA3");
	m_axesComboBox->insertItem(4, "YB1");
	m_axesComboBox->insertItem(5, "YB2");
	m_axesComboBox->insertItem(6, "YB3");

	//For adding operaname in the combobox
	if (!m_localOperaTable->empty())	
	for (Table<Operator>::reverse_iterator it = m_localOperaTable->rbegin(); it != m_localOperaTable->rend(); it++) {
                  
                  m_spaceOrOperaNameComboBox->insertItem(1, QString(it->getName().c_str())); 
          }
	//For adding space name in the combobox	
	if (!m_localSpaceTable->empty())	
	for (Table<Space>::reverse_iterator it = m_localSpaceTable->rbegin(); it != m_localSpaceTable->rend(); it++) {
                  
                  m_spaceOrOperaNameComboBox->insertItem(1, QString(it->getName().c_str())); 
          }
	//For adding modul names in the combobox
	if (!m_localModulTable->empty())	
	for (Table<Modul>::reverse_iterator it = m_localModulTable->rbegin(); it != m_localModulTable->rend(); it++) {
                  
                  m_modulNameComboBox->insertItem(1, QString(it->getName().c_str())); 
          }

	m_axesModel			= new QStandardItemModel(0, 1) ;
	m_modulNameModel		= new QStandardItemModel(0, 0) ;
	m_outlineModel			= new QStandardItemModel(0, 4) ;
		m_outlineModel->setHorizontalHeaderLabels(QStringList() << "     " << "     " << "     " << "     "); 

	m_axesListView->setModel(m_axesModel);
	m_modulNameListView->setModel(m_modulNameModel);
	m_outlineTreeView1->setModel(m_outlineModel);
	//m_outlineTreeView1->resizeColumnsToContents();
	//m_outlineTreeView1->setShowGrid(false);
	//connect(m_axesListView, SIGNAL(clicked(QModelIndex)), this, SLOT(deleteAxesRow(QModelIndex)));
	//connect(m_modulNameListView, SIGNAL(clicked(QModelIndex)), this, SLOT(deleteModulRow(QModelIndex)));
	
	connect(m_modinspaceDeleteButton, SIGNAL(clicked()), this, SLOT(deleteAxesRow()));
	connect(m_modinspaceDeleteButton, SIGNAL(clicked()), this, SLOT(deleteModulRow()));

	connect(m_rightAxesButton, SIGNAL(clicked()), this, SLOT(addTheAxesRow()));
	connect(m_rightModulNameButton, SIGNAL(clicked()), this, SLOT(addTheModulRow()));
	//connect(m_modinspaceDeleteButton, SIGNAL(clicked()), this, SLOT(deleteTheRow()));
	connect(m_beginOrEndComboBox, SIGNAL(currentIndexChanged (int )), this, SLOT(addBlockEndRow(int )));
	//connect(m_blocEndCheckBox, SIGNAL(clicked(bool )), this, SLOT(addBlockEndRow(bool )));
	//connect(m_endCheckBox, SIGNAL(clicked(bool )), this, SLOT(addEndRow(bool )));

}
/******************************** implementation of method ***********************************/
void ModinspaceWindow::addBlockEndRow(int anInt) {
	
	int col = m_outlineModel->columnCount();
	int row0 = m_outlineModel->rowCount();
	static int ordercounter = 1;	
	static int fordercounter = 0;

	switch(anInt) {
		case 0: break;
		case 1:{
				m_outlineModel->setItem(row0, ordercounter + 1, new QStandardItem("order")); 
				ordercounter++; 
			} break;
		case 2: {
			
				m_outlineModel->setItem(row0, ordercounter, new QStandardItem("forder")); 
				fordercounter++; 
			}break;
		case 3: {
				m_outlineModel->setItem(row0, 0, new QStandardItem("forder")); 	
				m_spaceOrOperaNameComboBox->setDisabled(true);
				m_axesComboBox->setDisabled(true);
			} break;
	}
	
	//if (row0 >= 2){
		
	//	m_outlineModel->setItem(1, col, new QStandardItem("forder")); 
	//}
}
/******************************** implementation of method ***********************************/
/*void ModinspaceWindow::addEndRow(bool aBool) {
	
	int row0 = m_outlineModel->rowCount();
	if (aBool && row0 >= 2)
		m_outlineModel->setItem(row0, 0, new QStandardItem("forder")); 
			
}*/
/********************************* Implementation of the selectedFunction(QModelIndex index) method  ***********************************/
/******************************** implementation of method ***********************************/
/*void ModinspaceWindow::callClicked(const QModelIndex &index) {
	
	QStandardItem *item = m_axesModel->itemFromIndex(index);	
	
	//cout << "Voici le text: " << item->text().toStdString() << endl; 
	
}*/
/********************************* Implementation of the selectedFunction(QModelIndex index) method  ***********************************/
void ModinspaceWindow::addTheAxesRow() {
	
	static int cpt = 0;
		
	QString theAxe = m_axesComboBox->currentText(); //
	string commonName;
	int row0 = m_outlineModel->rowCount();
	int row1 = m_outlineModel->rowCount() + 1;
	
	if (theAxe.isEmpty()) return; //If the axes combobox is not empty, the space combobox will be verified.

	if (m_spaceOrOperaNameComboBox->currentText().isEmpty()) {
	
		QMessageBox::critical(this, "Avis", "Précisez d'abord l'espace ou l'opérateur avant de faire le choix des axes.");
		return;
	}
	
	QString spaceOrOpera = m_spaceOrOperaNameComboBox->currentText();
		
	m_axesModel->setItem(m_axesModel->rowCount(), 0, new QStandardItem(theAxe));	
	m_axesComboBox->setCurrentIndex(0);

	if (!cpt) {
		
		Order ord(m_localModulTable);
			
		m_outlineModel->setItem(row0, 0, new QStandardItem("order")); 
		m_outlineModel->setItem(row0, 1, new QStandardItem("modinpace")); 
		m_outlineModel->setItem(row0, 2, new QStandardItem(spaceOrOpera)); 
		m_outlineModel->setItem(row1, 1, new QStandardItem("order")); 
	
		if(m_localSpaceTable->find(commonName)) {
			if(m_localSpaceTable->find(commonName)->isCounterOrderHeader()==false)
				{
					QMessageBox::critical(this, "Avis", "Ce nom d'espace a été déjà inséré.");
                 			return;
				}
			m_localSpaceTable->find(commonName)->setCounterOrderHeader(true);
			
		}
		else {
			if(m_localOperaTable->find(commonName)->isCounterOrderHeader()==false)
				{
					QMessageBox::critical(this, "Avis", "Ce nom d'operateur a été déjà inséré.");
                 			return;
				}

			m_localOperaTable->find(commonName)->setCounterOrderHeader(true);
		}
		
		ord.setOrderPhase(1);	
		cpt++;

	}	//m_theLocalModulTable->push_back();
	
	static int col = m_outlineModel->columnCount();
	m_outlineModel->setItem(1, col-2, new QStandardItem(theAxe)); 
		col++;
		//m_theLocalAxesTable->push_back(theAxe.toStdString());
	//m_outlineModel->setItem(row1, 1, new QStandardItem("order")); 

	//for (vector <string>::iterator it = m_theLocalAxesTable->begin(); it != m_theLocalAxesTable->end(); it++)
		//m_outlineModel->setItem(row1, m_outlineModel->columnCount(), new QStandardItem(QString(it->c_str()))); 
		//m_outlineModel->setItem(row1, m_outlineModel->columnCount(), new QStandardItem(QString(theAxe))); 
	//m_outlineModel->setItem(row1, 2, new QStandardItem("order")); 
	
	
	//if (m_blocEndCheckBox->isChecked())
	//	;
}

/********************************* Implementation of the addInstructionRow()  method *************************************************/
void ModinspaceWindow::addTheModulRow() {

	QString theModul = m_modulNameComboBox->currentText();
	
	int row0 =  m_outlineModel->rowCount();
	
	if (theModul.isEmpty()) return;

	m_modulNameModel->setItem(m_modulNameModel->rowCount(), 0, new QStandardItem(theModul));	
	m_outlineModel->setItem(row0, 2, new QStandardItem(theModul)); 

	m_spaceOrOperaNameComboBox->setDisabled(true);
	m_axesComboBox->setDisabled(true);

	m_modulNameComboBox->setCurrentIndex(0);

}

/******************************* Implementation of the deleteModulRow(const QModelIndex &index) method ****************************************/  
void ModinspaceWindow::deleteAxesRow() {
	
	//QStandardItem *item = m_axesModel->itemFromIndex(index);	

	QItemSelectionModel *selectionFromAxes = m_axesListView->selectionModel();
	//QItemSelectionModel *selectionFromModul = m_modulNameListView->selectionModel();

	indexForAxes = selectionFromAxes->currentIndex();
	//indexForModul = selectionFromModul->currentIndex();

	QVariant axesElement = m_axesModel->data(indexForAxes, Qt::DisplayRole);
	//QVariant modulElement = m_modulNameModel->data(indexForModul, Qt::DisplayRole);
	
	if(axesElement.toString().isEmpty())
		return;
		
	//if(!axesElement.toString().isEmpty())
		m_axesModel->removeRows(m_axesListView->currentIndex().row(), 1);// Le 2ème parametre indique le nombre de ligne à supprimer
	//else
	//	if(!modulElement.toString().isEmpty()) 
	//		m_modulNameModel->removeRows(m_modulNameListView->currentIndex().row(), 1);// Le 2ème parametre indique le nombre de ligne à supprimer


}

/******************************* Implementation of the deleteModulRow(const QModelIndex &index) method ****************************************/  
void ModinspaceWindow::deleteModulRow() {
	
	
	//QStandardItem *item = m_modulNameModel->itemFromIndex(index);	

	//QItemSelectionModel *selectionFromAxes = m_axesListView->selectionModel();
	QItemSelectionModel *selectionFromModul = m_modulNameListView->selectionModel();

	//indexForAxes = selectionFromAxes->currentIndex();
	indexForModul = selectionFromModul->currentIndex();

	//QVariant axesElement = m_axesModel->data(indexForAxes, Qt::DisplayRole);
	QVariant modulElement = m_modulNameModel->data(indexForModul, Qt::DisplayRole);
	
	if(modulElement.toString().isEmpty())
		return;
		
	//if(!axesElement.toString().isEmpty())
	//	m_axesModel->removeRows(m_axesListView->currentIndex().row(), 1);// Le 2ème parametre indique le nombre de ligne à supprimer
	//else
	//	if(!modulElement.toString().isEmpty()) 
			m_modulNameModel->removeRows(m_modulNameListView->currentIndex().row(), 1);// Le 2ème parametre indique le nombre de ligne à supprimer


}
/***********************************************************************************************************************/
/***************************************************** End of file *****************************************************/
/***********************************************************************************************************************/
