//! \file    SpaceintrajWindow.cpp
//! \brief   Implementation of the instructions file's window for visual_YAO.
//! \version 2010/10/29 (yyyy/mm/dd)
//! \author  MAYAKI Abdouramane.

/*
  Nom du Fichier: SpaceintrajWindow.cpp
  Nom de classe: SpaceintrajWindow
  Role:
  Nombre de methodes:
  Nombre d'attributs:
  */

#include "include/SpaceintrajWindow.hpp"

using namespace std;
using namespace yao;


//! \class OrderWindow(QWidget *parent) : QWidget(parent)
//! \brief Implementation of the Order window for visual_YAO.

/*********************************************************************************************************************************/
SpaceintrajWindow::SpaceintrajWindow(Table <Trajectory> *aTrajectoryTable, Table <Space> *aSpaceTable, Table <Operator> *anOperatorTable, Order *anOrder,  QWidget *parent) : QWidget(parent) {

	setupUi(this);

	m_rightSpaceNameButton->setIcon(QIcon("Images/icons/rightarrow2.png"));
	
	m_trajectoryTable       = aTrajectoryTable;
        m_spaceTable       	= aSpaceTable;
        m_operatorTable    	= anOperatorTable;
	m_localOrder		= anOrder;

	for (Table<Trajectory>::reverse_iterator it = m_trajectoryTable->rbegin(); it != m_trajectoryTable->rend(); it++) {
                 m_trajNameComboBox->insertItem(1, QString(it->getName().c_str())); 
        }    
	
	for (Table<Space>::reverse_iterator it = m_spaceTable->rbegin(); it != m_spaceTable->rend(); it++) {
                 m_spaceNameComboButton->insertItem(1, QString(it->getName().c_str())); 
        }       

	m_spaceOrOperanameModel	= new QStandardItemModel(0, 1);
	m_spaceOrOperaNameListView->setModel(m_spaceOrOperanameModel);

	m_outlineModel2	= new QStandardItemModel(0, 3);
		m_outlineModel2->setHorizontalHeaderLabels(QStringList() << "" << "" << "");

	m_outlineTreeView2->setModel(m_outlineModel2);
	/*

	connect(m_proposedParametersListView, SIGNAL(clicked(QModelIndex )), this, SLOT(selectedFunction(QModelIndex )));
	connect(m_rightButton, SIGNAL(clicked()), this, SLOT(addInstructionRow()));
	*/
	connect(m_rightSpaceNameButton, SIGNAL(clicked()), this, SLOT(addSpaceNameInListView()));
	//	connect(m_validationButton, SIGNAL(clicked()), this, SLOT(addTheEnd()));
}
/********************************* Implementation of the class *************************************************************************/
/********************************* Implementation of the selectedFunction(QModelIndex index) method  ***********************************/
/*void SpaceintrajWindow::selectedFunction(QModelIndex index) {

	QItemSelectionModel *selection = m_proposedParametersListView->selectionModel();
	//index = selection->currentIndex();
	QVariant element = m_instructionLeftModel->data(index, Qt::DisplayRole);
	QString chaine = element.toString();//.toStdString();
	m_fonctionNameLineEdit->setText(chaine);
	//QMessageBox::about(this, "Avis", chaine);
	//int r = index.row();
	
}*/

/********************************* Implementation of the addSpaceNameInListView()  method *************************************************/
void SpaceintrajWindow::addSpaceNameInListView() {
	
	static int row = m_spaceOrOperanameModel->rowCount();
	
	QString spaceNames = m_spaceNameComboButton->currentText();

	if (spaceNames.isEmpty()){ 
  
                      //      QMessageBox::critical(this, "Avertissement", "Le champ \"<I>Nom de la fonction<I>\" est obligatoire! Veuillez sélectionner une fonction parmi celles qui sont proposées dans la partie gauche de la fenêtre.");
                            return; // Arrêt de la méthode
        } 
	else {
		
		m_outlineModel2	->setItem(0, 0, new QStandardItem("order "));
		m_outlineModel2	->setItem(0, 1, new QStandardItem("spaceintraj "));
		m_outlineModel2	->setItem(0, 2, new QStandardItem(m_trajNameComboBox->currentText()));
	
		m_outlineModel2->setItem(row +1, 1, new QStandardItem(spaceNames));
		if (m_endCheckBox->isChecked()) emit theEndSignal(true); //m_outlineModel2->setItem(m_outlineModel2->rowCount(), 0, new QStandardItem("forder"));	;
		//m_outlineModel2->setItem(row +2, 0, new QStandardItem("forder"));
		//m_spaceOrOperaNameListView->setItem(m_spaceOrOperaNameListView->rowCount()-1, 1, new QStandardItem(val));
				
		m_spaceOrOperanameModel->setItem(m_spaceOrOperanameModel->rowCount(), 0, new QStandardItem(spaceNames));	;

		m_spaceNameComboButton->clearEditText();
		
		row++;
	}

/*	QString nom  = m_fonctionNameLineEdit->text();
        QString val  = m_fonctionParameterLineEdit->text();
	
	if (nom.isEmpty()){ 
  
                            QMessageBox::critical(this, "Avertissement", "Le champ \"<I>Nom de la fonction<I>\" est obligatoire! Veuillez sélectionner une fonction parmi celles qui sont proposées dans la partie gauche de la fenêtre.");
                            return; // Arrêt de la méthode
                    }
  
          else {
                  //if (!(m_ligneNom->text().isEmpty()) || (m_ligneValeur->text().isEmpty())) {
                    //      m_delButton->setEnabled(true);
                    //      Constant localConstant (Nom.toStdString(), Val.toStdString());
                    //              m_localConstantTable->push_back(localConstant);
			m_instructionRightModel->setItem(m_instructionRightModel->rowCount(), 0, new QStandardItem(nom));
			m_instructionRightModel->setItem(m_instructionRightModel->rowCount()-1, 1, new QStandardItem(val));
				
			m_fonctionNameLineEdit->setText("");
			m_fonctionParameterLineEdit->setText("");
                  }

*/
}
/***********************************************************************************************************************/
/***************************************************** End of file *****************************************************/
/***********************************************************************************************************************/
