/*
  Nom du Fichier: OrderWindow.hpp
  Nom de classe: OrderWindow
  Role:
  Functions:
  Attributs:
  */

#ifndef ORDERWINDOW_HPP
#define ORDERWINDOW_HPP


#include "../../ui_orderwindow.h"
#include "../../../YAOObjects/Table.hpp"
#include "../../../YAOObjects/Operator.hpp"
#include "../../../YAOObjects/Trajectory.hpp"
#include "../../../YAOObjects/Order.hpp"
#include "ModinspaceWindow.hpp"
#include "SpaceintrajWindow.hpp"

#include <QStandardItemModel>
#include <QStackedLayout>
#include <QRadioButton>
#include <QVBoxLayout>
#include <QHBoxLayout>

class OrderWindow : public QWidget, public Ui::OrderWindow {

	Q_OBJECT

	public :
            OrderWindow(yao::Table <yao::Trajectory> *aTrajectoryTable, yao::Table <yao::Space> *aSpaceTable, yao::Table <yao::Operator> *anOperatorTable, yao::Table <yao::Modul> *aModulTable, yao::Table <yao::Order> *anOrderTable, QWidget *parent=0);

	private slots:
		void theOrderHelp();
		void initializeTheCheckBox(bool);

	signals:
		void orderWindowIsClosed(int );

	protected:
		void closeEvent(QCloseEvent *event);

	private :
		QStandardItemModel *m_orderModel;
		QStackedLayout *stackedLayout;

		//QRadioButton *m_modinspaceRadioButton;
		//QRadioButton *m_spaceintrajRadioButton;
		
		QVBoxLayout *mainLayout;
		//QHBoxLayout *horizontalLayout;

		//QComboBox	*m_choiceComboBox;		
		bool stateOfSpaceintrajEndCheckBox;	
		yao::Table <yao::Trajectory> *m_localTrajectoryTable;
		yao::Table <yao::Space> *m_localSpaceTable;
		yao::Table <yao::Operator> *m_localOperaTable;
		yao::Table <yao::Modul> *m_localModulTable;
		yao::Table <yao::Order> *m_localOrderTable;
		yao::Order m_localOrder;
};
#endif // ORDERWINDOW_HPP
